# 事件类型列表信息-接口文档v1.0

> v1.0.0

### **请求方式**

**Content-Type**:

application/json

**POST**

**请求URL**：http://120.26.164.249:9892/spHj2017/eventList

> Body 请求参数

```json
{
    "companyCode": "10117",
    "current": 1,
    "size": 1,
    "startTime": "2023-01-07 19:00:00",
    "endTime": "2023-12-12 19:00:00"
}
```

### 请求参数说明

|名称|位置|类型|必选|说明|
|---|---|---|---|---|
|companyCode|body|String| 是 |单位编号|
|current|body|String| 是 |页数（要查看第几页数据）|
|size|body|String| 是 |页大小|
|startTime|body|String| 否 |开始时间（数据查询开始时间）|
|endTime|body|String| 否 |结束时间（数据查询结束时间）|

> 返回示例

```json
{
    "status": "SUCCESS",
    "code": "0",
    "msg": null,
    "data": {
        "waterAlarm": [
            {
                "alarm_type": "WP1",
                "alarm_time": "2023-03-07 12:45:07",
                "device_code": "648136056010000",
                "alarm_point": "0.0059"
            }
        ],
        "rtuAlarm": [
            {
                "alarm_type": "离线",
                "alarm_time": "2023-09-06 05:32:35",
                "device_code": "4023363030303435",
                "alarm_point": "1楼消防水泵房"
            }
        ],
        "firaAlarm": [
            {
                "alarm_type": "监测连线故障",
                "alarm_time": "2023-11-07 16:18:00",
                "device_code": "90049",
                "alarm_point": ""
            }
        ]
    },
    "exception": null
}
```

### 返回参数说明

| 名称        | 位置 | 类型   | 说明                                                         |
| ----------- | ---- | ------ | ------------------------------------------------------------ |
| waterAlarm  | data | String | 水报警（水系统事件）                                         |
| rtuAlarm    | data | String | rtu报警（rtu系统事件）                                       |
| firaAlarm   | data | String | 火报警（火系统事件）                                         |
| alarm_type  | data | String | 事件类型                                                     |
| alarm_time  | data | String | 事件时间                                                     |
| device_code | data | String | 设备编号                                                     |
| alarm_point | data | String | 压力值 mpa（waterAlarm）、名称（rtuAlarm）、端口号（firaAlarm） |

