# 在、离线设备查询

接口说明:根据appKey查询出对应单位编号下各类型设备在、离线数量

### **请求方式**

**Content-Type**:

application/json

**POST**

**请求URL**：http://120.26.164.249:9892/ytDeviceStatus/deviceList

### **请求参数**

**header**：

```json
{
  "appKey": "66ae33ee352490c55e78cde13cb14985"
}
```

### **header参数说明**

| 名称   | 位置   | 类型   | 必选 | 说明              |
| ------ | ------ | ------ | ---- | ----------------- |
| appKey | header | String | 是   | appKey（MD5加密） |

**body**：

```json
{
  "timestamp": "1702358542",
  "sign": "be3ce401cbb046be2eecb278a250ddcc"
}
```

**sign说明**	
sign = secretKey+#+timestamp+#+appKey

### **请求参数说明**

|名称|位置|类型|必选|说明|
|---|---|---|---|---|
|timestamp|body|String| 是 |时间戳（秒级）|
|sign|body|String| 是 |签名（MD5加密）|

### **返回结果**

> 返回示例

```json
{
    "status": "SUCCESS",
    "code": "0",
    "msg": null,
    "data": [
        {
            "deviceType": "rtu",
            "deviceTypeCounts": 1,
            "onlineCount": 1,
            "offlineCount": 0
        },
        {
            "deviceType": "水系统",
            "deviceTypeCounts": 10,
            "onlineCount": 6,
            "offlineCount": 4
        },
        {
            "deviceType": "液位",
            "deviceTypeCounts": 1,
            "onlineCount": 1,
            "offlineCount": 0
        },
    ],
    "exception": null
}
```

### **返回参数说明**

| 名称             | 位置 | 类型    | 说明         |
| ---------------- | ---- | ------- | ------------ |
| deviceType       | data | String  | 设备类型     |
| deviceTypeCounts | data | Integer | 设备总数     |
| onlineCount      | data | Integer | 在线设备数量 |
| offlineCount     | data | Integer | 离线设备数量 |
| alarmDeviceSum   | data | Long    | 告警设备总数 |





# 事件类型列表信息

接口说明:根据companyCode查询出对应单位编号下各类型在指定时间段内的事件信息列表

### **请求方式**

**Content-Type**:

application/json

**POST**

**请求URL**：http://120.26.164.249:9892/spHj2017/eventList

**header**：

```json
{
  "appKey": "66ae33ee352490c55e78cde13cb14985"
}
```

### **header参数说明**

| 名称   | 位置   | 类型   | 必选 | 说明              |
| ------ | ------ | ------ | ---- | ----------------- |
| appKey | header | String | 是   | appKey（MD5加密） |

**body**：

```json
{
  	"timestamp": "1702358542",
  	"sign": "be3ce401cbb046be2eecb278a250ddcc",
    "current": 1,
    "size": 1,
    "startTime": "2023-01-07 19:00:00",
    "endTime": "2023-12-12 19:00:00"
}
```

### 请求参数说明

**sign说明**	
sign = secretKey+#+timestamp+#+appKey

| 名称      | 位置 | 类型   | 必选 | 说明                         |
| --------- | ---- | ------ | ---- | ---------------------------- |
| timestamp | body | String | 是   | 时间戳（秒级）               |
| sign      | body | String | 是   | 签名（MD5加密）              |
| current   | body | String | 是   | 页数（要查看第几页数据）     |
| size      | body | String | 是   | 页大小                       |
| startTime | body | String | 否   | 开始时间（数据查询开始时间） |
| endTime   | body | String | 否   | 结束时间（数据查询结束时间） |

> 返回示例

```json
{
    "status": "SUCCESS",
    "code": "0",
    "msg": null,
    "data": {
        "waterAlarm": [
            {
                "alarm_type": "WP1",
                "alarm_time": "2023-03-07 12:45:07",
                "device_code": "648136056010000",
                "alarm_point": "0.0059"
            }
        ],
        "rtuAlarm": [
            {
                "alarm_type": "离线",
                "alarm_time": "2023-09-06 05:32:35",
                "device_code": "4023363030303435",
                "alarm_point": "1楼消防水泵房"
            }
        ],
        "firaAlarm": [
            {
                "alarm_type": "监测连线故障",
                "alarm_time": "2023-11-07 16:18:00",
                "device_code": "90049",
                "alarm_point": ""
            }
        ]
    },
    "exception": null
}
```

### 返回参数说明

| 名称        | 位置 | 类型   | 说明                                                         |
| ----------- | ---- | ------ | ------------------------------------------------------------ |
| waterAlarm  | data | String | 水报警（水系统事件）(LL1：液位；WP1：水压)                   |
| rtuAlarm    | data | String | rtu报警（rtu系统事件）                                       |
| firaAlarm   | data | String | 火报警（火系统事件）                                         |
| alarm_type  | data | String | 事件类型                                                     |
| alarm_time  | data | String | 事件时间                                                     |
| device_code | data | String | 设备编号                                                     |
| alarm_point | data | String | 压力值 mpa（waterAlarm）、名称（rtuAlarm）、端口号（firaAlarm） |





# 事件状态统计

接口说明:根据companyCode查询出对应单位编号下各类型在指定时间段内的事件状态统计

### **请求方式**

**Content-Type**:

application/json

**POST**

**请求URL**：http://120.26.164.249:9892/spHj2017/listCount

**header**：

```json
{
  "appKey": "66ae33ee352490c55e78cde13cb14985"
}
```

### **header参数说明**

| 名称   | 位置   | 类型   | 必选 | 说明              |
| ------ | ------ | ------ | ---- | ----------------- |
| appKey | header | String | 是   | appKey（MD5加密） |

**body**：

```json
{
  "timestamp": "1702358542",
  "sign": "be3ce401cbb046be2eecb278a250ddcc",
  "startTime": "2023-12-07 19:00:00",
  "endTime": "2023-12-12 19:00:00"
}
```

### 请求参数说明

**sign说明**	
sign = secretKey+#+timestamp+#+appKey

| 名称        | 位置 | 类型   | 必选 | 说明                         |
| ----------- | ---- | ------ | ---- | ---------------------------- |
| companyCode | body | String | 是   | 单位编号                     |
| startTime   | body | String | 否   | 开始时间（数据查询开始时间） |
| endTime     | body | String | 否   | 结束时间（数据查询结束时间） |

> 返回示例

```json
{
    "status": "SUCCESS",
    "code": "0",
    "msg": null,
    "data": {
        "processed": 280,
        "unprocess": 0,
        "processing": 0
    },
    "exception": null
}
```

### 返回参数说明

| 名称       | 位置 | 类型 | 说明                   |
| ---------- | ---- | ---- | ---------------------- |
| unprocess  | data | Long | 未处理（事件状态为 0） |
| processing | data | Long | 事件正在处理中         |
| processed  | data | Long | 已处理（事件状态为 1） |

